#include "vs1103.h"

	.sect code,rxvector
	.org 0x25
	jmpi _MyRxInt,(i6)+1	// RX	0x25

/*
    0xxxxxxx -> var = (var<<7) + xxxxxxx
    1000yyyy -> SCI_MODE+yyyy = var
	i.e. 02 00 03 8c -> 8003->AICTRL0
*/


	.sect code,RxInt
	.export _MyRxInt
_MyRxInt:
	stx mr0,(i6)+1	; sty i7,(i6)
	stx b0,(i6)+1	; sty a0,(i6)
	ldc UART_DATA,i7
	ldx (i7),a0
	ldc 0x80,b0
//0x0082  0xb0240024      AND A0,B0,B0
//0x0082  0xb0243c00      AND A0,B0,B0 ; STX A0,(I7)
	and a0,b0,b0	; stx a0,(i7)	//echo received bytes
	ldc SCI_MODE-0x80,b0
	jzs $1
	.import __stack
	ldc __stack,i7	//first word in the stack used for storage
	
	add a0,b0,b0	; ldx (i7),a0
	mv b0,i7
	j $0
	stx a0,(i7)	; ldy (i6)-1,null

$1:	ldx (i7),b0	; sty c0,(i6)
	ldc 7,c0
	ashl b0,c0,b0
	add a0,b0,b0
	stx b0,(i7)	; ldy (i6)-1,c0

$0:	ldx (i6)-1,b0	; ldy (i6),a0
	ldc INT_GLOB_ENA,i7
	ldx (i6),mr0
	reti
	stx i7,(i7)	; ldy (i6)-1,i7

/*
	10 0000000 0000000 = 0x8000
	00 0001000 0000100	
*/

/*
<- 0x65 'e' song/recoding ended
<- 0x70 'p' song paused
<- 0x63 'c' play continued
<- 0x6c 'l' song looped
<- 0x72 'r' recording started

*/

	.end
