#define ASM

	.import _SpiLoad

	// Actual SpiLoad makes a stub that makes a conversion between
	// the following two formats:
	//void SpiLoad (register __i2 short startAddr, register __i5 short m24)
	//void SpiLoad2(register __i2 short startAddr, register __i0 short m24)
	// The C compiler cannot take parameters in i5, so SpiLoad2 copies the
	// variable to i0 and calls the original function. The function never
	// returns, so no stack is saved.
	.sect code,SpiLoad2
	.export _SpiLoad2
_SpiLoad2:
	j _SpiLoad
	mv i0,i5

	.end
