#include "module.h"
#include "uartctrl.h"

/* Note: this file does not check the UART_CONTROL define */
void WriteIRam(register __i0 addr, register __a u_int32 val);
u_int32 ReadIRam(register __i0 addr);

void UartInit(void) {
    Disable();
    uartRxWrPtr = uartRxRdPtr = uartRxBuffer;
    WriteIRam(0x20+INT_EN_RX, ReadIRam((u_int16)MyRxIntCommand));
    //PERIP(INT_ENABLEL) |= INTF_RX;
    Enable();
#if 0
    /*read out any remaining chars*/
    while (UartFill()) {
	UartGetByte();
    }
#endif
}
